<template>
  <div>
    <div>
<CModal
           title="Info"
      size="sm"
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>


<CCardBody>
     <h5>Trace UWB Anchor Master</h5>
   
     <CDataTable
      :items="items"
      :fields="fields"
      table-filter
      items-per-page-select
      :items-per-page="5" 
      pagination
      hover
      striped
      border 
      sorter
     >
   

<!--Adding Customs buttons to each row -->
    <template #show_details="{item}" >
      <CButton size="sm" color="info" class="ml-1"  @click="ShowUpdateModal=true; SelectUWBAnchor(item)"> Update </CButton>
      <CButton size="sm" color="danger" class="ml-1" @click="ShowDeleteModal=true; SelectUWBAnchor(item)" >Delete</CButton>
      <CButton size="sm" color="dark" class="ml-1" @click="ShowDetailsModal=true; SelectUWBAnchor(item)"> Details </CButton>
    </template>

    </CDataTable>
      <CButton size="sm" color="info" class="" @click="ShowAddModal=true"> Add New UWB Anchor</CButton>
  </CCardBody>

 </div>
<div id="overlay" v-if="ShowAddModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Add New UWBAnchor</h5>
    <button type="button" class="close"  @click="ShowAddModal=false">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-7">
<form action="#" method="POST">

<!-- <div class="form-group">
<input type="text" name="uwB_Anchor_Id" class="form-control form-control-sm" placeholder="uwB Anchor Id" v-model="newUWBAnchor.uwB_Anchor_Id">
</div> -->

<div class="form-group"><label>Anchor Name</label>
<input type="text" name="uwD_Anchor_Name" class="form-control form-control-sm" placeholder="Anchor Name" v-model="newUWBAnchor.uwD_Anchor_Name">
</div>

<div class="form-group"><label>Anchor Make</label>
<input type="text" name="uwD_Anchor_Make" class="form-control form-control-sm" placeholder="Anchor Make" v-model="newUWBAnchor.uwD_Anchor_Make">
</div>

<div class="form-group"><label>Anchor Installed Date</label>
<input type="date" name="uwD_Anchor_Installed_Date" class="form-control form-control-sm" placeholder="Anchor Installed Date"  v-model="newUWBAnchor.uwD_Anchor_Installed_Date">
</div>

<!-- <div class="form-group">
<input type="text" name="uwD_Anchor_Status" class="form-control form-control-sm" placeholder=" uwD_Anchor_Status"  v-model="newUWBAnchor.uwD_Anchor_Status">
</div> -->

<div class="form-group">
<CButton size="sm" color="info" class=""  @click="ShowAddModal=false;addUWBAnchors();" > Add UWB Anchor </CButton>
</div>

</form>
 </div>
</div>
</div>
 </div>

<!-- Show Details Modal -->
<div id="overlay" v-if="ShowDetailsModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">UWBAnchor Details</h5>
    <button type="button" class="close"  @click="ShowDetailsModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body p-4">

<form action="#" method="POST">
<!-- <div class="form-group">
<input type="text" name="uwB_Anchor_Id" class="form-control form-control-sm" placeholder="uwB Anchor Id" v-model="newUWBAnchor.uwB_Anchor_Id">
</div> -->

<div class="form-group"><label>Anchor Name</label>
<input type="text" name="uwD_Anchor_Name" readonly class="form-control form-control-sm" placeholder="uwb Anchor Name" v-model="CurrentUWBAnchor.uwD_Anchor_Name">
</div>

<div class="form-group"><label>Anchor Make</label>
<input type="text" name="uwD_Anchor_Make" readonly class="form-control form-control-sm" placeholder="uwb Anchor Make" v-model="CurrentUWBAnchor.uwD_Anchor_Make">
</div>

<div class="form-group"><label>Installed Date</label>
<input type="text" name="uwD_Anchor_Installed_Date" readonly class="form-control form-control-sm" placeholder="uwb Anchor Installed Date"  v-model="CurrentUWBAnchor.uwD_Anchor_Installed_Date">
</div>

<!-- <div class="form-group">
<input type="text" name="uwD_Anchor_Status" class="form-control form-control-sm" placeholder=" uwb_Anchor_Status"  v-model="newUWBAnchor.uwD_Anchor_Status">
</div> -->

<div class="form-group">
<button class="btn btn-info btn-block btn-sm"  @click="ShowDetailsModal=false;" > Close </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Show Update Modal -->
<div id="overlay" v-if="ShowUpdateModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Update UWBAnchor</h5>
    <button type="button" class="close"  @click="ShowUpdateModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<form action="#" method="POST">
<!-- <div class="form-group">
<input type="text" name="uwB_Anchor_Id" class="form-control form-control-sm" placeholder="uwB Anchor Id" v-model="newUWBAnchor.uwB_Anchor_Id">
</div> -->

<div class="form-group"><label>Storage Loc Id</label>
<input type="text" name="uwD_Anchor_Name" class="form-control form-control-sm" placeholder="Uwb Anchor Name" v-model="CurrentUWBAnchor.uwD_Anchor_Name">
</div>

<div class="form-group"><label>Storage Loc Id</label>
<input type="text" name="uwD_Anchor_Make" class="form-control form-control-sm" placeholder="Uwb Anchor Make" v-model="CurrentUWBAnchor.uwD_Anchor_Make">
</div>

<div class="form-group"><label>Storage Loc Id</label>
<input type="date" name="uwD_Anchor_Installed_Date" class="form-control form-control-sm" placeholder="Uwb Anchor Installed Date"  v-model="CurrentUWBAnchor.uwD_Anchor_Installed_Date">
</div>

<!-- <div class="form-group">
<input type="text" name="uwD_Anchor_Status" class="form-control form-control-sm" placeholder=" uwD_Anchor_Status"  v-model="CurrentUWBAnchor.uwD_Anchor_Status">
</div> -->

<div class="form-group">
<button class="btn btn-info btn-block btn-sm"  @click="ShowUpdateModal=false;UpdateUWBAnchors();" > Update UWBAnchor </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Delete Modal -->
<div id="overlay" v-if="ShowDeleteModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Delete UWBAnchor</h5>
    <button type="button" class="close"  @click="ShowDeleteModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<h4 class="text-danger"> Are you sure want to delete the UWBAnchor ? </h4>
<h5> You are deleting {{ this.CurrentUWBAnchor.uwB_Anchor_Id +' || '+ this.CurrentUWBAnchor.uwD_Anchor_Name }}</h5>
<hr>
<button class="btn btn-danger btn-sm" @click="ShowDeleteModal=false; deleteItem();getAllUWBAnchorDetails()  "> Yes </button>
&nbsp;&nbsp;&nbsp;&nbsp;  
<button class="btn btn-success btn-sm" @click="ShowDeleteModal=false"> No </button>
</div>
</div>
</div>
</div>
</div>
</template>

<script>
const items = [
  { key: 'uwB_Anchor_Id', _style:'min-width:200px' },
  { key: 'uwD_Anchor_Name', _style:'min-width:100px;' },
  { key: 'uwD_Anchor_Make', _style:'min-width:50px;' }, 
  { key: 'uwD_Anchor_Installed_Date',     _style: 'width:1%',  }, 
  { key: 'uwD_Anchor_Status',     _style: 'width:1%',  },
 ]   
 const apiget =  'Trace_UWB_Anchor_Master/' 
//import CTableWrapper from '.@/Table.vue' 
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)

export default {
   //components: { CTableWrapper },
  data ()
  {
     return {
    items: items.map((item, id) => { return {...item, id}}),
    
     fields: [
      
            
              { key: 'uwB_Anchor_Id' , label: 'Id',_classes: 'font-weight-bold'},
              { key: 'uwD_Anchor_Name', label: 'UWB Anchor Name', },
              { key: 'uwD_Anchor_Make', label: 'UWB Anchor Make', _style: 'width:20%',},     
              { key: 'uwD_Anchor_Installed_Date',  label: 'Installed Date',  _style: 'width:20%', },             
             // { key: 'uwD_Anchor_Status',  label: 'UWB Anchor Status',  _style: 'width:12%', },
               { key: 'show_details',  label: '',  _style: 'width:30%', },
                    
      ],
 
  details: [],
  collapseDuration: 0,
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentUWBAnchor:"",
  ShowUpdateModal:"",
  ShowDetailsModal:"",
  smallModal: false,
  newUWBAnchor: {uwB_Anchor_Id:0,uwD_Anchor_Name:"",uwD_Anchor_Make:"",UWBAnchor_Type:"",uwD_Anchor_Installed_Date:"",uwD_Anchor_Status:1,}, }
  },


  
  mounted()
  {
   this.getAllUWBAnchorDetails();
  },

  methods:
  {
   getAllUWBAnchorDetails: function()
   {
  // Vue.axios.get('http://172.23.8.193:8095/api/FGS_FIFO_UWBAnchor_Master')
   Vue.axios.get(this.$url+ apiget)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.items =response.data.filter(x => x.uwD_Anchor_Status == 1);
       // this.subitems = response.data.fgS_FIFO_UWBAnchor_Type_Master;

       }
    });
   },

   
  addUWBAnchors()
  {
    if(this.items.find(x => x.uwD_Anchor_Name == this.newUWBAnchor.uwD_Anchor_Name && x.uwD_Anchor_Status == 1))
    {
     this.SuccessMsg= "uwb Anchor Name " + this.newUWBAnchor.uwD_Anchor_Name +" already exist. Please try another Name";
    this.smallModal = true;
    }
    else
    {

    Vue.axios.post(this.$url+ apiget,this.newUWBAnchor).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
        this.SuccessMsg ="Records Inserted Successfully.."
        this.getAllUWBAnchorDetails();
       }
    })
    }
   },

  UpdateUWBAnchors()
  {
    //alert(this.$url+ apiget + this.CurrentUWBAnchor.uwB_Anchor_Id);
      Vue.axios.put(this.$url+ apiget + this.CurrentUWBAnchor.uwB_Anchor_Id,this.CurrentUWBAnchor,).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
         this.SuccessMsg ="Records Updated Successfully.."
         this.getAllUWBAnchorDetails();
       }
    })
   },

  deleteItem()
    {
      var uwB_Anchor_Id = this.CurrentUWBAnchor.uwB_Anchor_Id;
        axios({   method: 'delete',
           url: this.$url+ apiget + uwB_Anchor_Id
    });
        this.SuccessMsg="UWBAnchor uwD_Anchor_Status Changed to Inactive Succesfully"
    },
      
  SelectUWBAnchor(UWBAnchor)
    {
     this.CurrentUWBAnchor=UWBAnchor;
    },
      
    },
  
    

}
</script>

<style scoped>
#overlay{
  position:fixed;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>